#include <Windows.h>
#include <stdio.h>

int APIENTRY wWinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPWSTR lpCmdLine,int nCmdShow){
  int argc=0;
  WCHAR**argv=CommandLineToArgvW(GetCommandLineW(),&argc);
  if (argc != 2)
      return 1;

  WCHAR const *pathToIniFile = argv[1];

  int width  = GetPrivateProfileInt(L"Document", L"PaperWidth", 0, pathToIniFile);
  int length = GetPrivateProfileInt(L"Document", L"PaperLength", 0, pathToIniFile);
  int pages  = GetPrivateProfileInt(L"Document", L"Pages", 0, pathToIniFile);
 
  ENHMETAHEADER hdr = {0};

  size_t const pathSize = 1024;
  WCHAR path[pathSize] = { 0 };
  size_t const keySize = 16;
  WCHAR key[keySize] = { 0 };
  HANDLE hFile;

  swprintf(key, keySize, L"%i", pages);
  WritePrivateProfileString(L"Preconverting", L"Count", key, pathToIniFile);

  for (DWORD i = 0; i < pages; ++i) {
       swprintf(key, keySize, L"File%i", i);
       GetPrivateProfileString(L"EMF", key, L"", path, pathSize, pathToIniFile);
	   if (wcslen(path)) {
		   hFile =  CreateFile(path, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		   if (hFile != INVALID_HANDLE_VALUE) {
			   DWORD countRead, countWrite;
			   if (ReadFile(hFile, &hdr, sizeof(hdr), &countRead, NULL)) {
				   // Set the page size based on the page size in the print job.
				   hdr.rclFrame.right  = width * 10;
				   hdr.rclFrame.bottom = length * 10;
				   // Set the size in millimeters to scale the image to fit the sheet.
				   hdr.szlMillimeters.cx = width / 10;
				   hdr.szlMillimeters.cy = length / 10;
				   SetFilePointer(hFile, 0, NULL, FILE_BEGIN);
                   WriteFile(hFile, &hdr, countRead, &countWrite, NULL);									 
				   WritePrivateProfileString(L"Preconverting", key, path, pathToIniFile);
			   }
			   CloseHandle(hFile);
		   }
       }
  }
  WritePrivateProfileString(L"Preconverting", L"Status", L"resumed", pathToIniFile);
  return 0;
}
